import bpy

from pathlib import Path


class ConfigLighting(bpy.types.Operator):
    """Add or conform a lighting build"""
    bl_idname = 'graou.lighting'
    bl_label = 'Config or update a lighting'

    def execute(self, context):
        # Look if a light object are in the scene to clear
        self.clear_light_on_scene()

        r = self.get_blend_resources_file()
        print(f'[Pipeline] Get file resource {r}')

        return {'FINISHED'}

    @staticmethod
    def get_blend_resources_file():
        """Get the blend file shared with the addon"""
        addon_folder = Path(bpy.utils.user_resource('SCRIPTS'))
        print(f'[Pipeline] Get addon folder "{addon_folder}"')
        addon_name = str(bpy.context.preferences.addons[__name__.split(".")[0]])
        print(f'[Pipeline] The addon name "{addon_name}"')

        return addon_folder.joinpath("addons", addon_name, "resources").as_posix()

    def get_world(self):
        pass

    def get_light_collection(self):
        pass

    def clear_light_on_scene(self):
        bpy.ops.object.select_all(action='DESELECT')

        for ob in bpy.data.objects:
            if ob.type == 'LIGHT' and self.find_collection(ob):
                ob.select_set(True)
                bpy.ops.object.delete()

            else:
                ob.select_set(False)

    @staticmethod
    def find_collection(ob, name='Lighting'):
        """Check if an object are attached with the Lighting collection"""
        for collection in ob.users_collection:
            if collection.name == name:
                return True
